// #autoload
// #name = SS Interpolate
// #version = 1.0
// #date = March 10, 2003
// #author = Chris Lee
// #warrior = Silverspirit
// #email = uncle_crewcut@hotmail.com
// #web = http://scripts.tribalwar.com/silverspirit
// #description = Changes interpolation.
// #category = Silverspirit's Scripts
// #status = Release
// #credit = LittleWing

if (!isObject(ssInterpolate))
    new ScriptObject(ssInterpolate) {
        class = ssInterpolate;
    };

package ssInterpolate {
    function ssInterpolate::Setup(%this) {
        if (%this.Setup)
            return;
        exec("gui/ssInterpolateDialog.gui");
        $RemapName[$RemapCount]="Interpolate";
        $RemapCmd[$RemapCount]="ssInterpolateHud";
        $RemapCount++;
        addMessageCallback('MsgClientJoin',ssInterpolateHandleClientJoin);
        %this.LoadPrefs();
        %this.Setup = true;
    }
    
    function DispatchLaunchMode() {
        parent::DispatchLaunchMode();
        if (!isObject(autoload))
            ssInterpolate.Setup();
    }
    
    function quit() {
        ssInterpolate.SavePrefs();
        parent::quit();
    }

    function ssInterpolate::LoadPrefs(%this) {
        if (isFile("prefs/ssInterpolate.cs"))
            exec("prefs/ssInterpolate.cs");
        ssInterpolateGui.getObject(4).setValue($Player::maxLatencyTicks);
        ssInterpolateGui.getObject(5).setValue($Player::maxPredictionTicks);
        ssInterpolateGui.getObject(6).setValue($Player::maxWarpTicks);
        ssInterpolateGui.getObject(7).setValue($Player::minWarpTicks);
    }

    function ssInterpolate::SavePrefs(%this) {
        export("$Player::*","prefs/ssInterpolate.cs");
    }

    function ssInterpolate::maxLatencyTicks(%this) {
        $Player::maxLatencyTicks = ssInterpolateGui.getObject(4).getValue();
    }
    
    function ssInterpolate::maxPredictionTicks(%this) {
        $Player::maxPredictionTicks = ssInterpolateGui.getObject(5).getValue();
    }
    
    function ssInterpolate::maxWarpTicks(%this) {
        $Player::maxWarpTicks = ssInterpolateGui.getObject(6).getValue();
    }
    
    function ssInterpolate::minWarpTicks(%this) {
        $Player::minWarpTicks = ssInterpolateGui.getObject(7).getValue();
    }
    
    function ssInterpolateHud(%val) {
        if (!%val)
            return;
        if (ssInterpolateDialog.getGroup() == GuiGroup.getId()) {
            Canvas.pushDialog(ssInterpolateDialog);
            ssInterpolateGui.setPosition(getWord(getResolution(),0) / 2 - 94,getWord(getResolution(),1) / 2 - 75);
        } else
            Canvas.popDialog(ssInterpolateDialog);
    }
    
    function ssInterpolateHandleClientJoin(%msgType, %msgString, %clientName, %clientId) {
        if (strStr(%msgString, "Welcome to Tribes") != -1)
            ssInterpolate.LoadPrefs();
    }
};
activatePackage(ssInterpolate);
if (isObject(autoload))
    ssInterpolate.Setup();
